xonotic/misc/tools/all/xonotic.subr

392 lines
11 KiB
Plaintext
Raw Normal View History

2012-03-01 13:09:29 +00:00
handled=true
case "$cmd" in
update-maps)
misc/tools/xonotic-map-compiler-autobuild download
;;
compile-map)
2013-06-16 17:44:16 +00:00
if [ $# -eq 0 ] ; then
msg "Usage: ./all compile-map mapname1 mapname2 mapname3"
msg "For example: ./all compile-map dance xoylent"
fi
2018-10-14 04:18:50 +00:00
if ! [ -f "netradiant/build/q3map2" ] ; then
msg "q3map2 needed! Building q3map2..."
cmake -H'netradiant' -B'netradiant/build' -G'Unix Makefiles' -D'CMAKE_BUILD_TYPE=Release' -DBUILD_RADIANT=OFF -DDOWNLOAD_GAMEPACKS=OFF
cmake --build 'netradiant/build' -- q3map2
fi
for mapfile in "$@"; do
mapfile="data/xonotic-maps.pk3dir/maps/$mapfile.map"
if [ ! -f "$mapfile" ] ; then
msg "ERROR, $mapfile not found!"
else
verbose measure_time misc/tools/xonotic-map-compiler-optionsfile "$mapfile"
fi
done
;;
2012-03-01 13:09:29 +00:00
compile)
cleand0=false
cleandp=false
cleanqcc=false
cleanqc=false
compiled0=
2019-09-27 13:15:49 +00:00
debug=release # when changing this default, change the description in the zsh autocompletion script
2012-03-01 13:09:29 +00:00
if [ -z "$CC" ]; then
export CC="gcc"
fi
export CC="$CC -DSUPPORTIPV6"
while :; do
case "$1" in
-0)
compiled0=true
shift
;;
-1)
compiled0=false
shift
;;
2012-03-01 13:09:29 +00:00
-c)
cleand0=true
cleandp=true
cleanqcc=true
cleanqc=true
shift
;;
-qc)
cleanqc=true
shift
;;
-d|-p|-r)
2012-03-01 13:09:29 +00:00
case "$1" in
-d)
debug=debug
;;
2012-03-01 13:09:29 +00:00
-p)
debug=profile
;;
-r)
debug=release
;;
esac
export CC="$CC -g"
case "`$CC -dumpversion`" in
[5-9]*|[1-9][0-9]*|4.[3-9]*|4.[1-9][0-9]*)
# gcc 4.3 or higher
# -march=native is broken < 4.3
if $CC -mtune=native -march=native misc/tools/conftest.c -o conftest >/dev/null 2>&1; then
export CC="$CC -mtune=native -march=native"
fi
;;
esac
if [ -n "$WE_HATE_OUR_USERS" ]; then
export CC="$CC -fno-common"
fi
shift
;;
*)
break
;;
esac
done
2014-09-02 12:56:34 +00:00
TARGETS="sv-$debug sdl-$debug"
2014-09-02 12:56:34 +00:00
if [ x"`uname`" = x"Darwin" ]; then
export CC="$CC -fno-reorder-blocks"
2012-03-01 13:09:29 +00:00
fi
2014-09-02 12:56:34 +00:00
2012-03-01 13:09:29 +00:00
if [ $# -gt 0 ] && [ x"$1" = x"" ]; then
# if we give the command make the arg "", it will surely fail (invalid filename),
# so better handle it as an empty client option
BAD_TARGETS=" "
shift
elif [ -n "$1" ]; then
BAD_TARGETS=
TARGETS_SAVE=$TARGETS
TARGETS=
for X in $1; do
case "$X" in
sdl)
TARGETS="$TARGETS sdl-$debug"
2012-03-01 13:09:29 +00:00
;;
dedicated)
TARGETS="$TARGETS sv-$debug"
2012-03-01 13:09:29 +00:00
;;
*)
BAD_TARGETS="$BAD_TARGETS $X"
;;
esac
done
if [ -n "$TARGETS" ]; then # at least a valid client
shift
else # no valid client, let's assume this option is not meant to be a client then
TARGETS=$TARGETS_SAVE
BAD_TARGETS=
fi
fi
2014-09-02 12:56:34 +00:00
if [ -z "$MAKE" ]; then
MAKE=make
fi
2012-03-01 13:09:29 +00:00
if [ -z "$MAKEFLAGS" ]; then
2012-03-03 16:07:56 +00:00
ncpus=`getconf _NPROCESSORS_ONLN 2>/dev/null || getconf NPROCESSORS_ONLN 2>/dev/null || echo 1`
if [ $ncpus -gt 1 ]; then
MAKEFLAGS=-j$ncpus
2012-03-01 13:09:29 +00:00
fi
if [ -n "$WE_HATE_OUR_USERS" ]; then
MAKEFLAGS="$MAKEFLAGS DP_MAKE_TARGET=mingw"
2012-03-01 13:09:29 +00:00
fi
fi
if [ -n "$WE_HATE_OUR_USERS" ]; then
2014-09-02 12:56:34 +00:00
# win32: use SDL2
case `uname -m` in
x86_64)
MAKEFLAGS="$MAKEFLAGS SDL_CONFIG=$d0/misc/builddeps/win64/sdl/bin/sdl2-config"
;;
*)
MAKEFLAGS="$MAKEFLAGS SDL_CONFIG=$d0/misc/builddeps/win32/sdl/bin/sdl2-config"
;;
esac
2014-09-02 12:56:34 +00:00
# win32: don't rely on jpeg includes
MAKEFLAGS="$MAKEFLAGS LIB_JPEG= CFLAGS_LIBJPEG="
fi
2014-09-02 12:56:34 +00:00
if [ x"`uname`" = x"Darwin" ]; then
# osx: use SDL2
f=$d0/misc/buildfiles/osx/Xonotic.app/Contents/Frameworks
MAKEFLAGS="$MAKEFLAGS SDLCONFIG_MACOSXCFLAGS=-I$f/SDL2.framework/Headers SDLCONFIG_MACOSXLIBS=-F$f SDLCONFIG_MACOSXLIBS+=-framework SDLCONFIG_MACOSXLIBS+=SDL2 SDLCONFIG_MACOSXLIBS+=-framework SDLCONFIG_MACOSXLIBS+=Cocoa SDLCONFIG_MACOSXLIBS+=-I$f/SDL2.framework/Headers SDLCONFIG_MACOSXSTATICLIBS=-F$f SDLCONFIG_MACOSXSTATICLIBS+=-framework SDLCONFIG_MACOSXSTATICLIBS+=SDL2 SDLCONFIG_MACOSXSTATICLIBS+=-framework SDLCONFIG_MACOSXSTATICLIBS+=Cocoa SDLCONFIG_MACOSXSTATICLIBS+=-I$f/SDL2.framework/Headers"
fi
# workaround ARM issue in DP's makefile.inc
case `uname -m` in
x86_64|*86)
;;
*)
MAKEFLAGS="$MAKEFLAGS CFLAGS_SSE= CFLAGS_SSE2="
;;
esac
2012-03-01 13:09:29 +00:00
if ! verbose $CC misc/tools/conftest.c -o conftest; then
msg ""
msg "~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~"
msg "~~~~~~~~~~ COMPILER ~~~~~~~~~~"
msg "~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~"
msg "~~~~~~~~~~~~~~_...._~~~~~~~~~~"
msg "~~~~~~~~~~~,-' \\\`-._~~~~~~"
msg "~~~~~~~~~~/ --. >< \\~~~~~"
msg "~~~~~~~~~/ (*)> -<: \\~~~~"
msg "~~~~~~~~~( ^~-' (*) )~~~~"
msg "~~~~~~~~~\\ ^+-_/ |~~~~"
msg "~~~~~~~~~~\\ {vvv} |~~~~"
msg "~~~~~~~~~~,\\ , {^^^},/~~~~~"
msg "~~~~~~~~,/ \`---.....-'~~W~~~~"
msg "~~~~~~,/ \\_____/_\\_W~~/~~~~~"
msg "~~~~~/ /~~~\\__/~~~~~~"
msg "~~~~/ /~~~~~~~~~~~~~~"
msg "~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~"
msg "~~~~~~~ Y U NO COMPILE ~~~~~~~"
msg "~~~~~~~~~~~~ CODE ~~~~~~~~~~~~"
msg "~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~"
msg ""
exit 1
fi
rm -f conftest
verbose cd "$d0/d0_blind_id"
if [ -z "$compiled0" ]; then
# In doubt, compile.
compiled0=true
2012-03-01 13:09:29 +00:00
# compilation of crypto library failed
# use binaries then, if we can...
mkdir -p .libs
if [ -n "$WE_HATE_OUR_USERS" ]; then
case `uname -m` in
x86_64)
verbose cp "$d0/misc/buildfiles/win64/libd0_blind_id"-* .libs/
verbose cp "$d0/misc/buildfiles/win64/libd0_rijndael"-* .libs/
verbose cp "$d0/misc/buildfiles/win64/libgmp"-* .libs/
compiled0=false
;;
*)
verbose cp "$d0/misc/buildfiles/win32/libd0_blind_id"-* .libs/
verbose cp "$d0/misc/buildfiles/win32/libd0_rijndael"-* .libs/
verbose cp "$d0/misc/buildfiles/win32/libgmp"-* .libs/
compiled0=false
;;
esac
2012-03-01 13:09:29 +00:00
else
case "`uname`" in
Linux)
case `uname -m` in
*86)
2013-09-12 16:32:09 +00:00
# No cp commands, we want to use static linking instead.
export CC="$CC -I../../../../misc/builddeps/linux32/d0_blind_id/include"
export CC="$CC -L../../../../misc/builddeps/linux32/d0_blind_id/lib"
export CC="$CC -Wl,-rpath,../../../../misc/builddeps/linux32/d0_blind_id/lib"
export CC="$CC -I../../../../misc/builddeps/linux32/gmp/include"
export CC="$CC -L../../../../misc/builddeps/linux32/gmp/lib"
export CC="$CC -Wl,-rpath,../../../../misc/builddeps/linux32/gmp/lib"
MAKEFLAGS="$MAKEFLAGS DP_LINK_CRYPTO=shared DP_LINK_CRYPTO_RIJNDAEL=shared LIB_CRYPTO=../../../../misc/builddeps/linux32/d0_blind_id/lib/libd0_blind_id.a LIB_CRYPTO+=../../../../misc/builddeps/linux32/gmp/lib/libgmp.a LIB_CRYPTO_RIJNDAEL=../../../../misc/builddeps/linux32/d0_blind_id/lib/libd0_rijndael.a"
compiled0=false
2012-03-01 13:09:29 +00:00
;;
*)
msg "Always need to compile libd0_blind_id on Linux `uname -m`."
2012-03-01 13:09:29 +00:00
;;
esac
;;
Darwin)
verbose cp "$d0/misc/buildfiles/osx/Xonotic.app/Contents/MacOS/libd0_blind_id".* .libs/
verbose cp "$d0/misc/buildfiles/osx/Xonotic.app/Contents/MacOS/libd0_rijndael".* .libs/
compiled0=false
2012-03-01 13:09:29 +00:00
;;
*)
msg "Always need to compile libd0_blind_id on `uname`."
2012-03-01 13:09:29 +00:00
;;
esac
fi
fi
if $compiled0; then
if $cleand0; then
if [ -f Makefile ]; then
verbose $MAKE $MAKEFLAGS distclean
2012-03-01 13:09:29 +00:00
fi
fi
if ! [ -f Makefile ]; then
verbose sh autogen.sh
verbose ./configure
fi
verbose $MAKE $MAKEFLAGS
2012-03-01 13:09:29 +00:00
fi
2013-05-06 14:15:06 +00:00
verbose cd "$d0/gmqcc"
if $cleanqcc; then
verbose $MAKE $MAKEFLAGS clean
2013-05-06 14:15:06 +00:00
fi
if [ -n "$WE_HATE_OUR_USERS" ]; then
verbose $MAKE $MAKEFLAGS gmqcc.exe
else
verbose $MAKE $MAKEFLAGS gmqcc
2013-05-06 14:15:06 +00:00
fi
2012-03-01 13:09:29 +00:00
if [ -n "$MSYSTEM" ]; then
DATAMAKE=mingw32-make
else
DATAMAKE=$MAKE
fi
2013-05-06 14:15:06 +00:00
verbose cd "$d0/data/xonotic-data.pk3dir"
if $cleanqc; then
verbose ${DATAMAKE} QCC="../../../../gmqcc/gmqcc" "$@" $MAKEFLAGS clean
2012-03-01 13:09:29 +00:00
fi
verbose ${DATAMAKE} QCC="../../../../gmqcc/gmqcc" "$@" $MAKEFLAGS
2012-03-01 13:09:29 +00:00
# 4 levels up: data, xonotic-data, qcsrc, server
verbose cd "$d0/darkplaces"
if [ x"$BAD_TARGETS" = x" " ]; then
$ECHO "Warning: invalid empty client, default clients will be used."
fi
if $cleandp; then
verbose $MAKE $MAKEFLAGS clean
2012-03-01 13:09:29 +00:00
fi
for T in $TARGETS; do
verbose $MAKE $MAKEFLAGS STRIP=: "$@" "$T"
2012-03-01 13:09:29 +00:00
done
for T in $BAD_TARGETS; do
$ECHO "Warning: discarded invalid client $T."
done
verbose "$SELF" update-maps
;;
run)
if [ -n "$WE_HATE_OUR_USERS" ]; then
case `uname -m` in
x86_64)
export PATH="$d0/misc/buildfiles/win64:$d0/d0_blind_id/.libs:$PATH"
;;
*)
export PATH="$d0/misc/buildfiles/win32:$d0/d0_blind_id/.libs:$PATH"
;;
esac
2012-03-01 13:09:29 +00:00
elif [ x"`uname`" = x"Darwin" ]; then
export DYLD_LIBRARY_PATH="$d0/misc/buildfiles/osx/Xonotic.app/Contents/MacOS:$d0/d0_blind_id/.libs"
export DYLD_FRAMEWORK_PATH="$d0/misc/buildfiles/osx/Xonotic.app/Contents/Frameworks"
else
2016-12-10 05:33:23 +00:00
export LD_LIBRARY_PATH="$d0/d0_blind_id/.libs${LD_LIBRARY_PATH:+:$LD_LIBRARY_PATH}"
2012-03-01 13:09:29 +00:00
fi
client=-sdl
USE_RLWRAP=no
2012-03-01 13:09:29 +00:00
case "$1" in
dedicated)
client=-$1
USE_RLWRAP=
shift
;;
sdl)
2012-03-01 13:09:29 +00:00
shift
;;
esac
2012-03-01 13:09:29 +00:00
if ! [ -x "darkplaces/darkplaces$client" ]; then
if [ -x "darkplaces/darkplaces$client.exe" ]; then
client=$client.exe
else
$ECHO "Client darkplaces/darkplaces$client not found, aborting"
exit 1
fi
fi
set -- "darkplaces/darkplaces$client" -xonotic "$@"
binary=$1
if [ x"$USE_GDB" = x"yes" ]; then
set -- gdb --args "$@"
USE_RLWRAP=no
elif [ x"$USE_GDB" = x"core" ]; then
2012-03-01 13:09:29 +00:00
set -- gdb --batch -x savecore.gdb --args "$@"
USE_RLWRAP=no
2012-03-01 13:09:29 +00:00
elif which catchsegv >/dev/null 2>&1; then
set -- catchsegv "$@"
fi
if [ x"$USE_RLWRAP" != x"no" ] && which rlwrap >/dev/null 2>&1; then
set -- rlwrap -A -g '^quit' -q "\"" -s 10000 -S ']' -w 100 "$@"
fi
2012-03-01 13:09:29 +00:00
rm -f xonotic.core
verbose measure_time "$@" || true
2012-03-01 13:09:29 +00:00
if [ -f xonotic.core ]; then
if yesno "The program has CRASHED. Do you want to examine the core dump?"; then
gdb "$binary" xonotic.core
#elif yesno "You did not want to examine the core dump. Do you want to provide it - including your DarkPlaces checkout - to the Xonotic developers?"; then
# tar cvzf xonotic.core.tar.gz xonotic.core darkplaces/*.c darkplaces/*.h
# # somehow send it
# rm -f xonotic.core.tar.gz
else
$ECHO "The core dump can be examined later by"
$ECHO " gdb $binary xonotic.core"
fi
exit 1
fi
;;
help)
$ECHO " $SELF compile [-c] [-qc] [-d|-p|-r] [-0] [-1] [sdl|dedicated]"
2012-03-01 13:09:29 +00:00
$ECHO " $SELF update-maps"
$ECHO " $SELF run [sdl|dedicated] options..."
2013-06-15 15:10:34 +00:00
$ECHO " $SELF compile-map mapname1 mapname2... (e.g. \"./all compile-map dance drain fuse\")"
2012-03-01 13:09:29 +00:00
handled=false
;;
serverbench)
# TODO(rpolzer): Why does :anticheat: output differ? Total game time differs? Why?
trap "rm -rf .serverbench_temp" 0 1 2 3 11 13 15
mkdir -p .serverbench_temp
2020-04-12 21:32:45 +00:00
verbose "$SELF" run dedicated "$@" -noconfig -userdir .serverbench_temp +exec serverbench.cfg |\
tee /dev/stderr |\
grep '^:' |\
grep -v '^:gamestart:' |\
grep -v '^:anticheat:' |\
md5sum
;;
2012-03-01 13:09:29 +00:00
*)
handled=false
;;
esac